## qlogo 0.92+git.1.29a5ca2

=== CMakeLists.txt ===
project(QLogo)

cmake_minimum_required(VERSION 3.5)

set(CMAKE_CXX_STANDARD 11)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)

set(CMAKE_AUTOUIC ON)

find_package(Qt5Widgets REQUIRED)

set(QLOGO_SOURCES qlogo_main.cpp mainwindow.cpp canvas.cpp console.cpp)

set(QLOGO_HEADERS mainwindow.h canvas.h console.h constants.h)

set(QLOGO_UI mainwindow.ui)

add_executable(QLogo ${QLOGO_SOURCES} ${QLOGO_HEADERS} ${QLOGO_UI})

target_link_libraries(QLogo Qt5::Widgets)



set(LOGO_SOURCES datum.cpp parser.cpp turtle.cpp vars.cpp kernel.cpp propertylists.cpp kernel_datastructureprimitives.cpp kernel_communication.cpp kernel_arithmetic.cpp kernel_graphics.cpp kernel_workspacemanagement.cpp workspace.cpp procedurehelper.cpp help.cpp kernel_controlstructures.cpp error.cpp library.cpp datum_word.cpp datum_astnode.cpp datum_list.cpp datum_array.cpp datum_datump.cpp datum_iterator.cpp logo_main.cpp qlogocontroller.cpp logocontroller.cpp controller.cpp)

set(LOGO_HEADERS datum.h parser.h turtle.h vars.h kernel.h propertylists.h workspace.h procedurehelper.h help.h error.h constants.h qlogocontroller.h logocontroller.h controller.h)

add_definitions(-DLOGOVERSION="0.93" -DCONTROLLER_HEADER="logo_controller.h")

if(APPLE)
  add_definitions(-DLOGOPLATFORM="OSX")
elseif(WIN32 OR MINGW OR MSYS OR CYGWIN)
  add_definitions(-DLOGOPLATFORM="WINDOWS")
else()
  add_definitions(-DLOGOPLATFORM="UNIX")
endif()

add_executable(logo ${LOGO_SOURCES} ${LOGO_HEADERS})

target_link_libraries(logo Qt5::Core Qt5::Widgets)

install(TARGETS QLogo logo RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

## qlogo 0.92

=== debian/changelog ===
qlogo (0.92-1) unstable; urgency=medium

  * Initial Release (closes: #905855)

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 09 Aug 2018 21:32:32 +0200

=== debian/control ===
Source: qlogo
Section: devel
Priority: optional
Maintainer: Barak A. Pearlmutter <bap@debian.org>
Standards-Version: 4.2.0
Homepage: https://qlogo.org/
Vcs-Git: https://salsa.debian.org/debian/QLogo.git
Vcs-Browser: https://salsa.debian.org/debian/QLogo
Build-Depends: debhelper (>= 11),
	qtbase5-dev

Package: qlogo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Language using turtle graphics famous for teaching kids
 QLogo is an interpreter for the Logo language written in C++ using
 Qt and OpenGL. Specifically, it mimics (as reasonably as possible)
 the UCBLogo interpreter developed at U.C. Berkeley. In fact, the
 UCBLogo manual describes about 99.9% of the functionality. You can
 find the UCBLogo Manual here:
 http://people.eecs.berkeley.edu/~bh/usermanual

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT = 5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- QLogo.pro

## qlogo 0.92+git.1.29a5ca2

=== debian/changelog ===
qlogo (0.92+git.1.29a5ca2-2) unstable; urgency=medium

  * Missing build dependency on cmake

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 07 Feb 2022 10:56:17 +0000

qlogo (0.92+git.1.29a5ca2-1) unstable; urgency=medium

  * Track upstream changes through 315d896 (just before Qt6 transition)
  * Add desktop file
  * Upstream installs executables in usr/bin itself
  * Upstream installs non-graphical executable as /usr/bin/logo; rename to QLogo-cli
  * Make QLogo-cli its own alternative
  * Update packaging scripts to upstream changes

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 06 Feb 2022 19:44:54 +0000

qlogo (0.92-2) unstable; urgency=low

  * Bump to debhelper 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Spelling patch
  * Tweak uscan support file debian/watch
  * Rules do not require root
  * Update standards version to 4.6.0, no changes needed.
  * Provide alternative for /usr/bin/logo

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 13 Jan 2022 19:51:58 +0000

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,14 @@
 Section: devel
 Priority: optional
 Maintainer: Barak A. Pearlmutter <bap@debian.org>
-Standards-Version: 4.2.0
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
 Homepage: https://qlogo.org/
 Vcs-Git: https://salsa.debian.org/debian/QLogo.git
 Vcs-Browser: https://salsa.debian.org/debian/QLogo
-Build-Depends: debhelper (>= 11),
-	qtbase5-dev
+Build-Depends: debhelper-compat (= 13),
+	cmake,
+	qtbase5-dev,
 
 Package: qlogo
 Architecture: any

=== debian/watch ===
version=4
https://github.com/jasonsikes/QLogo/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## qlogo 0.961

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(QLogo VERSION 0.961 LANGUAGES CXX)

include(GNUInstallDirs)

set(QLOGO_BIN qlogo)
set(QLOGO_GUI QLogo-GUI)
set(QLOGO_HELP qlogo_help.db)
set(QLOGO_LIB qlogo_library.db)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if (CMAKE_BUILD_TYPE)
    if(CMAKE_BUILD_TYPE STREQUAL "Release")
        set(CMAKE_OSX_ARCHITECTURES "arm64;x86_64")
    endif()
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(QT NAMES Qt6 REQUIRED COMPONENTS Widgets Sql Svg)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Widgets Sql Svg)

set(QLOGO_DATA_DIR "${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/${QLOGO_BIN}")
set(QLOGO_HELP_DB "${QLOGO_DATA_DIR}/${QLOGO_HELP}")
set(QLOGO_LIB_DB "${QLOGO_DATA_DIR}/${QLOGO_LIB}")

add_subdirectory("${QLOGO_BIN}")

add_subdirectory("${QLOGO_GUI}")

file(MAKE_DIRECTORY "${QLOGO_DATA_DIR}")

file(COPY "share/${QLOGO_HELP}" "share/${QLOGO_LIB}"
    DESTINATION "${QLOGO_DATA_DIR}"
)

file(COPY "${CMAKE_SOURCE_DIR}/test"
    DESTINATION "${CMAKE_BINARY_DIR}"
)

install(TARGETS "${QLOGO_GUI}" "${QLOGO_BIN}"
    BUNDLE DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(DIRECTORY "${QLOGO_DATA_DIR}"
    DESTINATION "${CMAKE_INSTALL_DATADIR}"
)

install(FILES "${QLOGO_GUI}.desktop"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/applications"
)

install(DIRECTORY "icons/hicolor"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/icons"
)

install(FILES "${QLOGO_GUI}.appdata.xml"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/metainfo"
)

if (APPLE)
    set(MACOSX_BUNDLE_ICON_FILE ${QLOGO_GUI}.icns)
    # Copy the qlogo binary and help database into the GUI bundle
    set(QLOGO_BIN_LOC ${CMAKE_BINARY_DIR}/${QLOGO_BIN}/${QLOGO_BIN})
    set(QLOGO_BUNDLE_EXE_DIR ${CMAKE_BINARY_DIR}/${QLOGO_GUI}/${QLOGO_GUI}.app/Contents/MacOS)
    set(QLOGO_BUNDLE_RESOURCES_DIR ${CMAKE_BINARY_DIR}/${QLOGO_GUI}/${QLOGO_GUI}.app/Contents/Resources)
    add_custom_target(QLogoBundleCp ALL
        COMMAND cp "${QLOGO_BIN_LOC}" "${QLOGO_BUNDLE_EXE_DIR}"
        COMMAND cp "${QLOGO_HELP_DB}" "${QLOGO_LIB_DB}" "${QLOGO_BUNDLE_RESOURCES_DIR}"
        DEPENDS "${QLOGO_GUI}" "${QLOGO_BIN}"
    )
endif()

=== QLogo-GUI/CMakeLists.txt ===
# Technically, the qlogo resource files belong to the qlogo binary,
# but on MacOS I want to put them into the QLogo-GUI bundle.
set(RESOURCE_FILES
  ../../share/qlogo_help.db
  ../../share/qlogo_lib.db
)
set(GUI_SOURCES
  canvas.cpp
  console.cpp
  editorwindow.cpp
  mainwindow.cpp
  qlogo_main.cpp

  ../include/gui/canvas.h
  ../include/gui/console.h
  ../include/gui/editorwindow.h
  ../include/gui/mainwindow.h
  ../include/sharedconstants.h

  editorwindow.ui
  mainwindow.ui
)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Sql)

set(MACOSX_BUNDLE_ICON_FILE "${QLOGO_GUI}.icns")

set(app_icon_macos "${CMAKE_SOURCE_DIR}/icons/${QLOGO_GUI}.icns")

set_source_files_properties(${app_icon_macos} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources")


if (WIN32)
    file(COPY "${CMAKE_SOURCE_DIR}/icons/${QLOGO_GUI}.ico"
    DESTINATION  "${CMAKE_SOURCE_DIR}/resources")
    set(app_icon_resource_windows "${CMAKE_SOURCE_DIR}/resources/${QLOGO_GUI}.rc")
    qt_add_executable("${QLOGO_GUI}"
      ${GUI_SOURCES}
      ${app_icon_resource_windows}
    )
else()
    qt_add_executable("${QLOGO_GUI}" MACOSX_BUNDLE
      ${GUI_SOURCES}
      ${app_icon_macos}
    )
endif()



target_include_directories("${QLOGO_GUI}" PUBLIC
  "${CMAKE_SOURCE_DIR}/include"
)


target_link_libraries("${QLOGO_GUI}" PRIVATE
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Svg
    Qt${QT_VERSION_MAJOR}::Sql
)

set_target_properties("${QLOGO_GUI}" PROPERTIES
  MACOSX_BUNDLE_GUI_IDENTIFIER jason.qlogo.org
  MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
  MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
  MACOSX_BUNDLE TRUE
  WIN32_EXECUTABLE TRUE
  RESOURCE "${RESOURCE_FILES}"
)

=== qlogo/CMakeLists.txt ===
set(QLOGO_SOURCES
  controller/inputqueue.cpp
  controller/logocontroller.cpp
  controller/logocontrollergui.cpp
  controller/textstream.cpp
  datum/datum.cpp
  datum/datum_array.cpp
  datum/datum_astnode.cpp
  datum/datum_datump.cpp
  datum/datum_iterator.cpp
  datum/datum_list.cpp
  datum/datum_word.cpp
  datum/error.cpp
  executor/kernel.cpp
  executor/arithmetic.cpp
  executor/communication.cpp
  executor/controlstructures.cpp
  executor/datastructureprimitives.cpp
  executor/graphics.cpp
  executor/workspacemanagement.cpp
  logo_main.cpp
  misc/library.cpp
  misc/procedurehelper.cpp
  misc/turtle.cpp
  parser/parser.cpp
  parser/runparser.cpp
  workspace/callframe.cpp
  workspace/procedures.cpp
  workspace/propertylists.cpp
  workspace/workspace.cpp

  ../include/sharedconstants.h
  ../include/controller/inputqueue.h
  ../include/controller/logocontroller.h
  ../include/controller/logocontrollergui.h
  ../include/controller/textstream.h
  ../include/datum.h
  ../include/astnode.h
  ../include/error.h
  ../include/kernel.h
  ../include/primitives.h
  ../include/library.h
  ../include/procedurehelper.h
  ../include/turtle.h
  ../include/parser.h
  ../include/runparser.h
  ../include/workspace/callframe.h
  ../include/workspace/primitivetable.h
  ../include/workspace/procedures.h
  ../include/workspace/propertylists.h
  ../include/workspace/workspace.h
)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Sql)

qt_add_executable("${QLOGO_BIN}"
  ${QLOGO_SOURCES}
)

target_include_directories("${QLOGO_BIN}" PUBLIC
  "${CMAKE_SOURCE_DIR}/include"
)

add_definitions(-DLOGOVERSION="${PROJECT_VERSION}")

if(APPLE)
  add_definitions(-DLOGOPLATFORM="OSX")
elseif(WIN32 OR MINGW OR MSYS OR CYGWIN)
  add_definitions(-DLOGOPLATFORM="WINDOWS")
else()
  add_definitions(-DLOGOPLATFORM="UNIX")
endif()

target_link_libraries("${QLOGO_BIN}" PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Sql
)

set_target_properties("${QLOGO_BIN}" PROPERTIES
  WIN32_EXECUTABLE TRUE
)

=== debian/changelog ===
qlogo (0.961-1) unstable; urgency=medium

  * New upstream version
  * Transition from Qt5 to Qt6
  * Upstream renamed README to README.md
  * Build dependencies: cmake, libqt6opengl6-dev, qt6-svg-dev
  * dh_installalternatives
  * Update QLogo-tryway to qt6
  * Install upstream desktop file
  * Install upstream icon
  * Update standards version
  * Update debian/watch uscan support file
  * Update debian/copyright

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 12 Sep 2024 08:13:14 +0100

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Section: devel
 Priority: optional
 Maintainer: Barak A. Pearlmutter <bap@debian.org>
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://qlogo.org/
 Vcs-Git: https://salsa.debian.org/debian/QLogo.git
 Vcs-Browser: https://salsa.debian.org/debian/QLogo
 Build-Depends: debhelper-compat (= 13),
 	cmake,
-	qtbase5-dev,
+	qt6-base-dev, libqt6opengl6-dev,
+	qt6-svg-dev,
 
 Package: qlogo
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT = 6
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

=== debian/watch ===
version=4

# Upstream uses multiple format for tags, need to deal. Examples:
#   QLogo-v0.94alpha
#   version_0.96
#   v0.94alpha3

https://github.com/jasonsikes/QLogo/tags .*/[a-z_-]+?@ANY_VERSION@@ARCHIVE_EXT@
